# variant of StraightSelection
# minimum and maximum is computed in parallel
# like BubbleSort and ShakerSort

proc MinMaxSelection {} {
    global field

    set len $field(len)

    for {
	set i 0
	set j [expr $len -1]
    } {
	$i < $j
    } {
	incr i
	incr j -1
    } {
	set minix $i
	set maxix $i
	set min   $field($minix)
	set max   $min

	for {set k [expr $i + 1]} {$k <= $j} {incr k} {

	    if {[compare $field($k) < $min]} {
		set minix $k
		set min   $field($minix)
	    } else {
		if {[compare $max < $field($k)]} {
		    set maxix $k
		    set max   $field($k)
		}
	    }
	}

	# swaps
	set field($minix) $field($i)
	set field($i) $min

	# recompute maxix
	if {$maxix == $i} {set maxix $minix}

	set field($maxix) $field($j)
	set field($j) $max
    }
}